package pwc.taxtech.atms.controller;

import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.calendar.dao.ext.CalendarExtMapper;
import pwc.taxtech.atms.calendar.entity.CalendarConfiguration;
import pwc.taxtech.atms.calendar.entity.CalendarTaskType;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.calendar.CalendarConfigQueryParamDto;
import pwc.taxtech.atms.dto.calendar.CalendarDisplayQueryParamDto;
import pwc.taxtech.atms.service.ICalendarService;

import javax.annotation.Resource;

/**
 * <p> @Description </p>
 *
 * @Author: Mccoy Z Xia (Xia zhixin)
 * @Date: 2019-07-10 13:59
 * @Version: 1.0
 **/
@RestController
@RequestMapping("api/v1/calendar/")
public class CalendarController {

    private static final Logger log = LoggerFactory.getLogger(CalendarController.class);

    @Autowired
    private ICalendarService calendarServiceImpl;

    @PostMapping("saveTaskType")
    public OperationResultDto saveTaskType(@RequestBody CalendarTaskType calendarTaskType){
        return calendarServiceImpl.saveTaskType(calendarTaskType);
    }

    @GetMapping("getAllTaskTypeList")
    public OperationResultDto getAllTaskTypeList(){
        return calendarServiceImpl.getAllTaskTypeList();
    }

    @GetMapping("getTaskTypeList")
    public OperationResultDto getTaskTypeList(){
        return calendarServiceImpl.getTaskTypeList();
    }

    @GetMapping("getMaxConfigOrder")
    public OperationResultDto getMaxConfigOrder(){
        return calendarServiceImpl.getMaxConfigOrder();
    }

    @PostMapping("getCalendarDataForDisplay")
    public OperationResultDto getCalendarDataForDisplay(@RequestBody CalendarDisplayQueryParamDto queryParamDto){
        return calendarServiceImpl.getCalendarDataForDisplay(queryParamDto);
    }

    @PostMapping("saveCalendarConfig")
    public OperationResultDto saveCalendarConfig(@RequestBody CalendarConfiguration calendarConfig){
        return calendarServiceImpl.saveCalendarConfig(calendarConfig);
    }

    @GetMapping("getCalendarConfigById/{id}")
    public OperationResultDto getCalendarConfigById(@PathVariable("id") Long id){
        return calendarServiceImpl.getCalendarConfigById(id);
    }

    @PostMapping("getCalendarConfigList")
    public OperationResultDto getCalendarConfigList(@RequestBody CalendarConfigQueryParamDto queryParam){
        return calendarServiceImpl.getCalendarConfigList(queryParam);
    }

    @GetMapping("getActiveEntityList")
    public OperationResultDto getActiveEntityList(){
        return calendarServiceImpl.getActiveEntityList();
    }

}
