package pwc.taxtech.atms.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import pwc.taxtech.atms.calendar.entity.CalendarEvent;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.ICalendarEventService;

import javax.annotation.Resource;

/**
 * <p> @Description </p>
 *
 * @Author: Mccoy Z Xia (Xia zhixin)
 * @Date: 2019-07-10 14:29
 * @Version: 1.0
 **/
@Resource
@RequestMapping("api/v1/calendarEvent/")
public class CalendarEventController {

    @Autowired
    private ICalendarEventService calendarEventServiceImpl;

    @PostMapping("add")
    public OperationResultDto addEvent(@RequestBody CalendarEvent event){
        return calendarEventServiceImpl.addEvent(event);
    }

    @PostMapping("update")
    public OperationResultDto updateEvent(@RequestBody CalendarEvent event){
        return calendarEventServiceImpl.updateEvent(event);
    }

    @GetMapping("delete/{id}")
    public OperationResultDto deleteEvent(@PathVariable("id") Long id){
        return calendarEventServiceImpl.deleteEvent(id);
    }

}
