package pwc.taxtech.atms.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import pwc.taxtech.atms.calendar.dao.CalendarActionJurisdictionRelationshipMapper;
import pwc.taxtech.atms.calendar.dao.CalendarActionMapper;
import pwc.taxtech.atms.calendar.dao.CalendarJurisdictionMapper;
import pwc.taxtech.atms.calendar.entity.CalendarAction;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.ICalendarActionService;

import javax.annotation.Resource;
import java.util.Date;

/**
 * <p> @Description </p>
 *
 * @Author: Mccoy Z Xia (Xia zhixin)
 * @Date: 2019-07-10 16:19
 * @Version: 1.0
 **/
public class CalendarActionServiceImpl extends BaseService implements ICalendarActionService {

    private static final Logger log = LoggerFactory.getLogger(CalendarActionServiceImpl.class);

    @Resource
    private CalendarActionMapper calendarActionMapper;

    @Resource
    private CalendarJurisdictionMapper calendarJurisdictionMapper;

    @Resource
    private CalendarActionJurisdictionRelationshipMapper calendarActionJurisdictionRelationshipMapper;

    @Override
    public OperationResultDto saveEvent(CalendarAction record) {
        int count = 0;
        try {
            record.setUpdateTime(new Date());
            // 无ID则新建，有ID则更新
            if (record.getId() != null){
                count = calendarActionMapper.updateByPrimaryKeySelective(record);
            } else {
                record.setId(idService.nextId());
                record.setCreateTime(record.getUpdateTime());
                count = calendarActionMapper.insert(record);
            }

        } catch (Exception e) {
            log.error("save error", e);
        }
        boolean result = count > 0;
        String msg = result ? "1" : "0";
        return new OperationResultDto(result, msg);
    }

    @Override
    public OperationResultDto deleteEvent(Long id) {
        int count = 0;
        try {
            count = calendarActionMapper.deleteByPrimaryKey(id);
        } catch (Exception e) {
            log.error("deleteAction error", e);
        }
        boolean result = count > 0;
        String msg = result ? "删除成功" : "删除失败";
        return new OperationResultDto(result, msg);
    }

}
