package pwc.taxtech.atms.calendar.dao.ext;

import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.calendar.dto.CalendarTaskTypeDto;
import pwc.taxtech.atms.calendar.dto.EntityDto;

import java.util.List;
import java.util.Map;


/**
 * <p> @Description </p>
 *
 * @Author: Mccoy Z Xia (Xia zhixin)
 * @Date: 2019-07-10 18:20
 * @Version: 1.0
 **/
@Mapper
public interface CalendarExtMapper extends MyMapper {

    @Select("SELECT id FROM calendar_task_type WHERE name = #{name} LIMIT 1")
    Long checkTaskTypeNameIsExist(String name);

    @Select("SELECT id, name FROM calendar_task_type WHERE status = 1 ORDER BY id")
    List<CalendarTaskTypeDto> getAllTaskTypeList();

    @Select("SELECT id, name FROM calendar_task_type WHERE status = 1 AND id > 1 ORDER BY id")
    List<CalendarTaskTypeDto> getTaskTypeList();

    @Select("SELECT id, name FROM organization WHERE is_active = 1")
    List<EntityDto> getActiveEntityList();

    @Select("SELECT id, name FROM organization")
    List<EntityDto> getAllEntityList();

    @Select("SELECT id, name FROM calendar_task_type")
    @MapKey("id")
    Map<Long, CalendarTaskTypeDto> getAllTaskTypeMapList();

    @Select("SELECT id, name FROM organization")
    @MapKey("id")
    Map<Long, EntityDto> getAllEntityMapList();

    @Select("SELECT id, name FROM organization WHERE is_active = 1")
    @MapKey("id")
    Map<Long, EntityDto> getActiveEntityMapList();

    @Select("SELECT name FROM calendar_task_type WHERE id IN (${ids})")
    List<String> getAllTaskTypes(@Param("ids") String ids);

    @Select("SELECT name FROM organization WHERE id IN (${ids})")
    List<String> getAllEntities(@Param("ids") String ids);

    @Select("SELECT order_Index FROM calendar_configuration ORDER BY id DESC LIMIT 1")
    Integer getMaxConfigOrder();
}
