package pwc.taxtech.atms.organization.dpo;


import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.List;

@Getter
@Setter
@ToString
public class OrganizationHKDto {
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;
    private String name;
    private String code;
    private Boolean isActive;
    private Long parentId;
    private String legalForm;
    private String registerAddress;
    private Float authorisedCapital;
    private Float issuedCapital;
    private String industry;
    private String paymentOfAnnualGovernmentFee;
    private String annualReturnFillings;
    private String boardMeetingRequirement;
    private String businessLicense;
    private String renewalOfBusinessLicense;
    private String entityLevel;
    private String dateOfIncorporation;
    private String jurisdictionOfFormation;
    private String financialYearEnd;
    private String annualAuditRequirement;
    private String registeredAgent;
    private String ownershipForm;
    private String residentSecretary;
    private String createTime;
    private String updateTime;
    private String areaId;
    private String regionId;
    private String structureId;
    private String industryId;
    private String businessUnitId;
    private String parentName;
    private List<OrganizationHKDto> subOrgs;
    private Integer pLevel;
    private Integer level;
    @JsonProperty("directors")
    private List<OrganizationDirectorDto> directors;
    @JsonProperty("shareholders")
    private List<OrganizationShareholderDto> shareholders;
    @JsonProperty("attachments")
    private List<OrganizationAttachmentDto> attachments;
}
