﻿commonModule.controller('editOrganizationModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', '$filter', 'SweetAlert', 'orgHKService', 'ackUibModal', '$rootScope',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, $filter, SweetAlert, orgHKService, ackUibModal, $rootScope) {

        var selectedModel = '.addOrgControlPop'; //'#addOrgControlPop' + $scope.dimensionId;

        $scope.pleaseSelect = $translate.instant('PleaseSelect');
        $scope.startDate = new Date(new Date().getFullYear() - 20, 1, 1);
        $scope.endDate = new Date(new Date().getFullYear() + 20, 1, 1);
        $scope.viewMode = 'days';

        var defaultSelcectRegion = {
            id: 0,
            name: '',
            shortName: '',
            mergerName: ''
        };

        $scope.showPage = function (pageIndex) {

            // if (pageIndex === 0)
            // {
            //     $('#orgModalFooter').css('padding-left','139px');
            // } else{
            //     $('#orgModalFooter').css('padding-left','35px');
            // }

        };

        // 新建机构
        var newOrg = function () {
            $scope.editOrgModel = {
                TypeLevel: 1,
                code: ''

            };

            refreshOrg();

            $scope.isAdd = true;
            $scope.isShowBasic = false;
            $scope.isShowAdvanced = false;
            $scope.isShowRight = false;
            $scope.selfDimensionError = false;

            // 选项清空
            $scope.selectLevelType = null;
            $scope.selectProvince = null;
            $scope.selectRegionID = null;

            $scope.componentSelectedArea = null;
            $scope.selectRegion = defaultSelcectRegion;
            $scope.selectProjectIndustry = null;
            $scope.selectBusinessUnit = null;
            if ($scope.newOrganization) {

                // 默认事业部
                if ($scope.newOrganization.businessUnitID) {
                    $scope.selectBusinessUnit = _.find($scope.businessUnitList, function (num) {
                        return num.ID === $scope.newOrganization.businessUnitID;
                    });
                }

                // 默认区域
                if ($scope.newOrganization.areaID && $scope.newOrganization.areaName) {
                    $scope.editOrgModel.areaID = $scope.newOrganization.areaID;
                    $scope.editOrgModel.areaName = $scope.newOrganization.areaName;
                }
            }


            // $scope.orgAccountList = [];
            $scope.serviceList = [];
            $scope.isCheckedServiceList = [];
            // $scope.OrgAccountRowIndex = 1;
            // $scope.newOrgAccountRow();

            // $scope.selfDimensionModel = getAddOrgSetDimension();
            // initIsCheckedServiceList();
            // resetErrorStatus();
            // if ($scope.isShow) {
            //     $scope.orgControlForm.$setPristine();
            //     $('#orgControlTab a:first').tab('show');
            //     // $(selectedModel).modal('show');
            // }
            // $scope.advancedControlForm.$setPristine();
            // set first active page is basic info
            // $('#orgModalFooter').css('padding-left','139px');
        };

        $scope.nameKeyUp = function () {
            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);

            if (hasSpecialChar) {
                $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
            } else {
                $scope.editOrgModel.nameError = null;
            }
        };

        // 保存机构
        $scope.saveOrg = function () {
            var dxResult = DevExpress.validationEngine.validateGroup($('#orgControlForm').dxValidationGroup("instance")).isValid;
            if (dxResult) {
                saveLocalOrg();
            }
        };

        var saveLocalOrg = function () {
            // var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);
            // if (hasSpecialChar) {
            //     $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
            //     $scope.isShowBasic = true;
            //     return false;
            // }

            // if ($scope.orgControlForm.$invalid) {
            //     $scope.isShowBasic = true;
            //     return;
            // } else {
            //     $scope.isShowBasic = false;
            // }

            var editModel = $scope.editOrgModel;

            if ($scope.isAdd) {
                editModel.isActive = true;
                editModel.shareholders = $scope.shareholderDatasource;
                editModel.directors = $scope.directorDatasource;
                orgHKService.addOrg(editModel).success(function (orgId) {
                    if (orgId && !orgId.result) {
                        SweetAlert.warning($translate.instant(orgId.resultMsg));
                        return;
                    }
                    $scope.modalManage.editOrgModal.close();
                    SweetAlert.success($translate.instant('SaveSuccess'));
                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            } else {
                orgHKService.updateOrg(editModel).success(function (data) {
                    if (data && !data.result) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }
                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            }
        };

        // 加载机构
        var loadOrg = function (orgId) {
            //清空组织机构，重新获取，达到刷新效果
            $scope.editOrgModel = {
                TypeLevel: 1
            };

            refreshOrg();
            $scope.isShowBasic = false;
            // $scope.orgControlForm.$setPristine();

            if (!orgId) {
                orgId = $scope.selectCompany.id;
            }
            // $("#selectedOrgName-error").hide();
            $scope.isAdd = false;
            $scope.orgHasAccountMapping = false;
            orgHKService.getSingleOrg(orgId).success(function (orgData) {
                $scope.selectCompany = orgData;
                $scope.editOrgModel = orgData;
                $scope.editOrgModel.foundationDate = ($filter('date')(new Date($scope.editOrgModel.foundationDate), "yyyy-MM-dd"));
                $scope.orgAccountList = [];
                $scope.serviceList = [];
                $scope.OrgAccountRowIndex = 1;
            });
        };

        $scope.removeDisabled = function () {
            var businessUnitList = $scope.businessUnitList;
            $scope.businessUnitList = _.without(businessUnitList, _.findWhere(businessUnitList, {
                id: 'newadd'
            }));
        };

        // 验证开始时间
        $scope.checkStartDate = function (row) {

            if (row.startDate && !window.PWC.checkMonth(row.startDate)) {
                row.startDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.startDateError = null;
            }

            if (!row.startDate) {
                row.startDateError = $scope.resources.EffectiveDateRequired;
            } else {
                row.startDateError = null;
            }

            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 验证结束时间
        $scope.checkEndDate = function (row) {
            if (row.endDate && !window.PWC.checkMonth(row.endDate)) {
                row.endDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.endDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.endDateError = null;
                return;
            }

            if (row.startDate && row.endDate) {
                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 说明
        $scope.resources = {
            OrganizationName: $translate.instant('OrganizationName'),
            OrganizationNameEn: $translate.instant('OrganizationNameEn'),
            RegistrationCapital: $translate.instant('RegistrationCapital'),
            LegalPersonName: $translate.instant('LegalPersonName'),
            NumOfBranches: $translate.instant('NumOfBranches'),
            BusinessScope: $translate.instant('BusinessScope'),
            UnifiedSocialCreditCode: $translate.instant('UnifiedSocialCreditCode'),
            Abbreviation: $translate.instant('Abbreviation'),
            RegistrationLocationEn: $translate.instant('RegistrationLocationEn'),

            PaidInCapital: $translate.instant('PaidInCapital'),
            FoundationDate: $translate.instant('FoundationDate'),

            registrationLocation: $translate.instant('RegistrationLocation'),
            OrganizationMsgNameRequired: $translate.instant('OrganizationMsgNameRequired'),
            OrganizationParent: $translate.instant('OrganizationParent'),
            OrganizationLevelType: $translate.instant('OrganizationLevelType'),
            OrganizationMsgLevelTypeRequired: $translate.instant('OrganizationMsgLevelTypeRequired'),
            OrganizationClientCode: $translate.instant('OrganizationClientCode'),
            OrganizationMsgClientCodeRequired: $translate.instant('OrganizationMsgClientCodeRequired'),
            OrganizationCode: $translate.instant('OrganizationCode'),
            OrganizationMsgCodeRequired: $translate.instant('OrganizationMsgCodeRequired'),
            OrganizationMsgCodeMaxLength: $translate.instant('OrganizationMsgCodeMaxLength'),
            OrganizationMsgCodePattern: $translate.instant('OrganizationMsgCodePattern'),
            OrganizationMsgCodeUnique: $translate.instant('OrganizationMsgCodeUnique'),
            OrganizationTaxPayerNumber: $translate.instant('OrganizationTaxPayerNumber'),
            OrganizationMsgTaxPayerNumberUnique: $translate.instant('OrganizationMsgTaxPayerNumberUnique'),
            OrganizationMsgAreaRequired: $translate.instant('OrganizationMsgAreaRequired'),
            OrganizationMsgProvinceRequired: $translate.instant('OrganizationMsgProvinceRequired'),
            OrganizationMsgRegStatusRequired: $translate.instant('OrganizationMsgRegStatusRequired'),
            OrganizationMsgEngageNationalProhibitIndustryRequired: $translate.instant('OrganizationMsgEngageNationalProhibitIndustryRequired'),
            OrganizationMsgArchitectureTypeRequired: $translate.instant('OrganizationMsgArchitectureTypeRequired'),
            OrganizationMsgCityRequired: $translate.instant('OrganizationMsgCityRequired'),
            OrganizationMsgEnterpriseAccountSetRequired: $translate.instant('OrganizationMsgEnterpriseAccountSetRequired'),
            EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
            ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
            EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
            OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
            OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
            DateMonthFormatError: $translate.instant('DateMonthFormatError')
        };

        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == constant.Operation.Add) {
                    // add
                    newOrg();
                } else if (newValue == constant.Operation.Edit) {
                    // if ($scope.selectedOrganization) {
                    //     loadOrg($scope.selectedOrganization.id);
                    // }
                }
            }
        });

        $scope.changeInternational = function () {
            $scope.isLocal = false;
            $scope.isInternational = true;
            $('.localRequired').removeAttr("required");
            $('.orgAreaRequired').removeAttr("required");
        };

        $scope.changeLocal = function () {
            $scope.isLocal = true;
            $scope.isInternational = false;
            $('.localRequired').attr("required", true);
            $('.orgAreaRequired').attr("required", true);
        };

        // 强制刷新机构控件里的机构
        var refreshOrg = function () {
            $scope.editOrgModel.componentSelectedOrg = {};
            $scope.editOrgModel.componentSelectedOrg.forceRefresh = true;
        };

        $(".addOrgControlPop").on("hidden.bs.modal", function () {
            $('.modal-backdrop').remove();
            $(".addOrgControlPop").hide();
            $scope.operateType = null;

        });

        $scope.closeModal = function () {
            $scope.operateType = null;
            $scope.modalManage.editOrgModal.cancel();
        };

        $scope.addEquity = function () {
            $scope.isShowShareholderModal = true;
        };

        $scope.addDirector = function () {
            $scope.isShowDirectorModal = true;
        };

        // 初始化参数信息
        var initParams = function () {
            $scope.editOrgModel = {};
            $scope.selectCompany = {};
            $scope.directorDatasource = [];
            $scope.shareholderDatasource = [];
            $scope.gModel = {};

            $scope.isLocal = true;
            // 登记状态
            $scope.regStatusList = constant.RegStatusList;
            $scope.architectureTypeList = constant.ArchitectureTypeList;
            $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
            $scope.trueFalse = constant.trueFalse;

            $scope.dropdownDatasource = {
                countryCNList: constant.countryCNList,
                legalFormTypeList: constant.organizationHK.legalFormTypeList,
                entityLevelTypeList: constant.organizationHK.EntityLevel,
                jurisdictionOfFormationTypeList: constant.organizationHK.JurisdictionOfFormation,
                ownershipFormTypeList: constant.organizationHK.OwnershipForm
            };
            var now = new Date();
            $scope.equityGridOptions = {
                bindingOptions: {
                    dataSource: 'shareholderDatasource'
                },
                height: 150,
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "investmentEntity",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('investmentEntity'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "ownershipForm",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('ownershipForm'),
                    },
                    {
                        dataField: "commonOrPreferred",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('commonOrPreferred'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "classOfShares",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('classOfShares'),
                    },
                    {
                        dataField: "votingPercentage",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('votingPercentage'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editShareholder(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteShareholder(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.shareholderGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            $scope.directorGridOptions = {
                bindingOptions: {
                    dataSource: 'directorDatasource'
                },
                height: 160,
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "directorName",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('directorName')
                    },
                    {
                        dataField: "residency",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('residency'),
                    },
                    {
                        dataField: "dateOfAppointment",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('dateOfAppointment'),
                        dataType: "date",
                        format: "yyyy-MM-dd"
                    },
                    {
                        dataField: "dateOfResignation",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('dateOfResignation'),
                        dataType: "date",
                        format: "yyyy-MM-dd"
                    },
                    {
                        dataField: "executive",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('executive'),
                    },
                    {
                        dataField: "otherRoles",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('otherRoles'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editDirector(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteDirector(\'' + options.data.id + '\')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.directorGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            $scope.textBoxOption = {
                nameOption: {
                    bindingOptions: {
                        value: 'editOrgModel.name'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('OrganizationName')
                },
                codeOption: {
                    bindingOptions: {
                        value: 'editOrgModel.code'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('OrganizationCode')
                },
                legalFormOption: {
                    bindingOptions: {
                        dataSource: 'dropdownDatasource.legalFormTypeList',
                        value: 'editOrgModel.legalForm'
                    },
                    onSelectionChanged: function (args) {
                        // $scope.editOrgModel.legalForm = args.selectedItem.id;
                    },
                    itemTemplate: function (itemData, itemIndex, itemElement) {
                        var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                        itemElement.append(span);
                    },
                    noDataText: $translate.instant('NoDataText'),
                    valueExpr: 'id',
                    displayExpr: 'name'
                },
                registerAddressOption: {
                    bindingOptions: {
                        value: 'editOrgModel.registerAddress'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('registerAddress')
                },
                authorisedCapitalOption: {
                    bindingOptions: {
                        value: 'editOrgModel.authorisedCapital'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('authorisedCapital')
                },
                issuedCapitalOption: {
                    bindingOptions: {
                        value: 'editOrgModel.issuedCapital'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('issuedCapital')
                },
                industryOption: {
                    bindingOptions: {
                        value: 'editOrgModel.industry'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('industry')
                },
                businessLicenseOption: {
                    bindingOptions: {
                        value: 'editOrgModel.businessLicense'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('businessLicense')
                },
                entityLevelOption: {
                    bindingOptions: {
                        dataSource: 'dropdownDatasource.entityLevelTypeList',
                        value: 'editOrgModel.entityLevel'
                    },
                    onSelectionChanged: function (args) {
                        // $scope.editOrgModel.entityLevel = args.selectedItem.id;
                    },
                    itemTemplate: function (itemData, itemIndex, itemElement) {
                        var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                        itemElement.append(span);
                    },
                    noDataText: $translate.instant('NoDataText'),
                    valueExpr: 'id',
                    displayExpr: 'name'
                },
                jurisdictionOfFormationOption: {
                    bindingOptions: {
                        dataSource: 'dropdownDatasource.jurisdictionOfFormationTypeList',
                        value: 'editOrgModel.jurisdictionOfFormation'
                    },
                    onSelectionChanged: function (args) {
                        // $scope.editOrgModel.jurisdictionOfFormation = args.selectedItem.id;
                    },
                    itemTemplate: function (itemData, itemIndex, itemElement) {
                        var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                        itemElement.append(span);
                    },
                    noDataText: $translate.instant('NoDataText'),
                    valueExpr: 'id',
                    displayExpr: 'name'
                },
                financialYearEndOption: {
                    bindingOptions: {
                        value: 'editOrgModel.financialYearEnd'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('financialYearEnd')
                },
                registeredAgentOption: {
                    bindingOptions: {
                        value: 'editOrgModel.registeredAgent'
                    },
                    maxLength: 100,
                    placeholder: $translate.instant('registeredAgent')
                },
                ownershipFormOption: {
                    bindingOptions: {
                        dataSource: 'dropdownDatasource.ownershipFormTypeList',
                        value: 'editOrgModel.ownershipFormType'
                    },
                    onSelectionChanged: function (args) {
                        // $scope.editOrgModel.ownershipFormType = args.selectedItem.id;
                    },
                    itemTemplate: function (itemData, itemIndex, itemElement) {
                        var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                        itemElement.append(span);
                    },
                    noDataText: $translate.instant('NoDataText'),
                    valueExpr: 'id',
                    displayExpr: 'name'
                },
                dateOfIncorporationOption: {
                    bindingOptions: {
                        value: 'editOrgModel.dateOfIncorporation'
                    },
                    type: "date",
                    value: now,
                    displayFormat: constant.date.dateFormatyyyyMMdd,
                    dateSerializationFormat: constant.date.dateFormatyyyyMMdd
                }
            };

            $scope.validateOption = {
                nameOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('OrganizationName')
                        }
                    ]
                },
                codeOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('OrganizationCode')
                        }
                    ]
                },
                legalFormOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('LegalForm')
                        }
                    ]
                },
                registerAddressOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('registerAddressOption')
                        }
                    ]
                },
                authorisedCapitalOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('authorisedCapital')
                        }
                    ]
                },
                issuedCapitalOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('issuedCapital')
                        }
                    ]
                },
                industryOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('industry')
                        }
                    ]
                },
                businessLicenseOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('businessLicense')
                        }
                    ]
                },
                entityLevelOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('OrganizationName')
                        }
                    ]
                },
                jurisdictionOfFormationOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('jurisdictionOfFormation')
                        }
                    ]
                },
                financialYearEndOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('financialYearEnd')
                        }
                    ]
                },
                registeredAgentOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('registeredAgent')
                        }
                    ]
                },
                ownershipFormOption: {
                    validationRules: [
                        {
                            type: "required",
                            message: $translate.instant('ownershipForm')
                        }
                    ]
                }
            }
        };

        $scope.isShow = false;

        $scope.closeSharehoder = function () {
            $scope.isShowShareholderModal = false;
        };

        $scope.saveShareholder = function (shareholderEntity) {
            var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                return item.id === shareholderEntity.id;
            });

            if (shareholder && shareholder.length > 0) {
                $scope.shareholderDatasource = _.without($scope.shareholderDatasource, shareholder[0]);
            }
            $scope.shareholderDatasource.push(shareholderEntity);
        };

        window.editShareholder = function (id) {
            console.log("editShareholder    " + id);
            var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                return item.id === id;
            });

            if (shareholder && shareholder.length > 0) {
                $scope.gModel.editShareholderModel = shareholder[0];
                $scope.isShowShareholderModal = true;
            }
        };


        window.deleteShareholder = function (id) {
            console.log("deleteShareholder    " + id);
            var shareholder = _.filter($scope.shareholderDatasource, function (item) {
                return item.id === id;
            });
            if (shareholder && shareholder.length > 0) {
                $scope.shareholderDatasource = _.without($scope.shareholderDatasource, shareholder[0]);
            }
        };

        $scope.closeDirector = function () {
            $scope.isShowDirectorModal = false;
        };

        $scope.saveDirector = function (directorEntity) {
            var director = _.filter($scope.directorDatasource, function (item) {
                return item.id === directorEntity.id;
            });

            if (director && director.length > 0) {
                $scope.directorDatasource = _.without($scope.directorDatasource, director[0]);
            }
            $scope.directorDatasource.push(directorEntity);
        };

        window.editDirector = function (id) {
            console.log("editDirector    " + id);
            var director = _.filter($scope.directorDatasource, function (item) {
                return item.id === id;
            });

            if (director && director.length > 0) {
                $scope.gModel.editDirectorModel = director[0];
                $scope.isShowDirectorModal = true;
            }
        };

        window.deleteDirector = function (id) {
            console.log("deleteDirector    " + id);
            var director = _.filter($scope.directorDatasource, function (item) {
                return item.id === id;
            });
            if (director && director.length > 0) {
                $scope.directorDatasource = _.without($scope.directorDatasource, director[0]);
            }
        };

        //模态框管理
        $scope.modalManage = {
            editOrgModal: {
                open: function () {
                    $scope.modalInstance = ackUibModal($scope,
                        'edit-organization-modal.html',
                        'edit-organization-modal-wrapper',
                        $scope.parentPage, 'static', function () {
                            $scope.isShow = false;
                            $scope.isShowShareholderModal = false;
                            $scope.isShowDirectorModal = false;
                            ackMessageBox.close();
                        });
                    $scope.modalInstance.open();
                },
                close: function () {
                    $scope.modalInstance.close();
                },
                cancel: function () {
                    $scope.modalInstance.cancel();
                }
            }
        };

        $scope.$watch('isShow', function (newValue, oldValue) {
            if (newValue) {
                $scope.modalManage.editOrgModal.open();
                if ($scope.isAdd) {
                    $scope.editOrgModel = {};
                    $scope.selectCompany = {};
                    $scope.directorDatasource = [];
                    $scope.shareholderDatasource = [];
                }
                else {
                    $scope.editOrgModel = $scope.selectedOrganization;
                    $scope.selectCompany = $scope.selectedOrganization;
                }
            }
        });

        (function initialize() {
            $log.debug('editOrganizationModalController.ctor()...');
            $scope.maxdropLength = 20;
            $scope.maxTitleLength = 10;
            initParams();
        })();
    }
])
;
