commonModule.controller('editOrganizationShareholderModalController', ['$scope', '$log', 'ackUibModal', '$translate', function ($scope, $log, ackUibModal, $translate) {
    'use strict';
    //模态框管理
    $scope.modalManage = {
        shareholderModal: {
            open: function () {
                $scope.modalInstance = ackUibModal($scope,
                    'edit-organization-shareholder-modal.html',
                    'edit-organization-shareholder-modal-wrapper',
                    null, 'static', function () {
                        $scope.isShowS = false;
                        ackMessageBox.close();
                    });
                $scope.modalInstance.open();
            },
            close: function () {
                $scope.onClose();
                $scope.modalInstance.close();
            },
            cancel: function () {
                $scope.onClose();
                $scope.modalInstance.cancel();
            },
            save: function () {
                var dxResult = DevExpress.validationEngine.validateGroup($('#shareholderControlForm').dxValidationGroup("instance")).isValid;
                if (dxResult) {
                    if (!$scope.editModelS.id) {
                        $scope.editModelS.id = PWC.newGuid();
                    }
                    $scope.onSave({shareholderEntity: $scope.editModelS});
                    $scope.editModelS = {};
                    $scope.modalManage.shareholderModal.close();
                }
            }
        }
    };

    var initParams = function () {
        $scope.ownershipFormTypeList = constant.organizationHK.OwnershipForm;
        $scope.commonOrPreferredTypeList = ['Commmon', 'Preferred'];
        $scope.classOfSharesTypeList = ['A', 'B'];

        $scope.dropdownDatasource = {
            investmentEntityTypeList: [],
            ownershipFormTypeList: constant.organizationHK.OwnershipForm,
            commonOrPreferredTypeList: [{id: 1, name: 'Commmon'}, {id: 2, name: 'Preferred'}],
            classOfSharesTypeList: [{id: 1, name: 'A'}, {id: 2, name: 'B'}]
        };

        $scope.textboxOption = {
            investmentEntityOption: {
                bindingOptions: {
                    dataSource: 'dropdownDatasource.ownershipFormTypeList',
                    value: 'editModelS.investmentEntity'
                },
                onSelectionChanged: function (args) {
                    // $scope.editModelS.investmentEntity = args.selectedItem.id;
                },
                itemTemplate: function (itemData, itemIndex, itemElement) {
                    var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                    itemElement.append(span);
                },
                noDataText: $translate.instant('NoDataText'),
                valueExpr: 'id',
                displayExpr: 'name'
            },
            ownershipFormOption: {
                bindingOptions: {
                    dataSource: 'dropdownDatasource.ownershipFormTypeList',
                    value: 'editModelS.ownershipForm'
                },
                onSelectionChanged: function (args) {
                    // $scope.editModelS.ownershipForm = args.selectedItem.id;
                },
                itemTemplate: function (itemData, itemIndex, itemElement) {
                    var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                    itemElement.append(span);
                },
                noDataText: $translate.instant('NoDataText'),
                valueExpr: 'id',
                displayExpr: 'name'
            },
            commonOrPreferredOption: {
                bindingOptions: {
                    dataSource: 'dropdownDatasource.commonOrPreferredTypeList',
                    value: 'editModelS.commonOrPreferred'
                },
                onSelectionChanged: function (args) {
                    // $scope.editModelS.commonOrPreferred = args.selectedItem.id;
                },
                itemTemplate: function (itemData, itemIndex, itemElement) {
                    var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                    itemElement.append(span);
                },
                noDataText: $translate.instant('NoDataText'),
                valueExpr: 'id',
                displayExpr: 'name'
            },
            classOfSharesOption: {
                bindingOptions: {
                    dataSource: 'dropdownDatasource.classOfSharesTypeList',
                    value: 'editModelS.classOfShares'
                },
                onSelectionChanged: function (args) {
                    // $scope.editModelS.classOfShares = args.selectedItem.id;
                },
                itemTemplate: function (itemData, itemIndex, itemElement) {
                    var span = $('<span title="' + itemData.name + '">').text(itemData.name);
                    itemElement.append(span);
                },
                noDataText: $translate.instant('NoDataText'),
                valueExpr: 'id',
                displayExpr: 'name'
            },
            votingPercentageOption: {
                bindingOptions: {
                    value: 'editModelS.votingPercentage'
                },
                maxLength: 100,
                placeholder: $translate.instant('votingPercentage'),
                width: 300
            }
        };

        $scope.validateOption = {
            investmentEntityOption: {
                validationRules: [
                    {
                        type: "required",
                        message: $translate.instant('investmentEntity')
                    }
                ]
            },
            ownershipFormOption: {
                validationRules: [
                    {
                        type: "required",
                        message: $translate.instant('ownershipForm')
                    }
                ]
            },
            commonOrPreferredOption: {
                validationRules: [
                    {
                        type: "required",
                        message: $translate.instant('commonOrPreferred')
                    }
                ]
            },
            classOfSharesOption: {
                validationRules: [
                    {
                        type: "required",
                        message: $translate.instant('classOfShares')
                    }
                ]
            },
            votingPercentageOption: {
                validationRules: [
                    {
                        type: "required",
                        message: $translate.instant('votingPercentage')
                    }
                ]
            }
        };
    };

    var init = function () {

    };

    var thisModuleService = {
        initEvents: function () {
        },

        initWatches: function () {
            $scope.$watch('isShowS', function (newValue) {
                if (newValue) {
                    if ($scope.$parent.$parent.gModel) {

                        console.log($scope.$parent.$parent.gModel.editShareholderModel);
                        $scope.editModelS = $scope.$parent.$parent.gModel.editShareholderModel;
                    }
                    $scope.modalManage.shareholderModal.open();
                }
            });
        }
    };

    (function initialize() {
        $log.debug('editOrganizationShareholderModalController.ctor()...');
        $scope.editModelS = {};
        initParams();
        init();
        thisModuleService.initWatches();
        thisModuleService.initEvents();
    })();
}]);