// web service proxy for org
webservices.factory('orgHKService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getOrgInfoList: function () {
            return $http.get('/orgHK/getOrgInfoList', apiConfig.create());
        },
        enableOrgs: function (id) {
            return $http.get('/orgHK/enableOrgs?orgId=' + id, apiConfig.create());
        },
        disableOrgs: function (orgList) {
            return $http.post('/orgHK/disableOrgs', orgList, apiConfig.create());
        },
        updateOrg: function (org) {
            return $http.put('/orgHK/update', org, apiConfig.create());
        },
        getOrgListToJson: function (type) {
            return $http.get('/orgHK/getjson?useType=' + type, apiConfig.create());
        },
        getSingleOrg: function (orgId) {
            return $http.get('/orgHK/displaySingle?orgId=' + orgId, apiConfig.create());
        },
        addOrg: function (org) {
            return $http.post('/orgHK/add', org, apiConfig.create());
        },
        addDirecotr: function (orgDirector) {
            return $http.post('/orgHK/addDirecotr', orgDirector, apiConfig.create());
        },
        addShareholder: function (orgShareholder) {
            return $http.post('/orgHK/addShareholder', orgShareholder, apiConfig.create());
        },
        updateDirector: function (orgDirector) {
            return $http.put('/orgHK/updateDirector', orgDirector, apiConfig.create());
        },
        updateShareholder: function (orgShareholder) {
            return $http.put('/orgHK/updateShareholder', orgShareholder, apiConfig.create());
        },
        updateDirectors: function (orgDirectors) {
            return $http.post('/orgHK/updateDirectors', orgDirectors, apiConfig.create());
        },
        updateShareholders: function (orgShareholders) {
            return $http.post('/orgHK/updateShareholders', orgShareholders, apiConfig.create());
        },
        attachmentDownload: function (attachmentId) {
            return $http.get('/orgHK/downloadAttachment?attachmentId=' + attachmentId, apiConfig.create({responseType: 'arraybuffer'}));
        },
        attachmentDelete: function (attachmentId) {
            return $http.delete('/orgHK/downloadAttachment?attachmentId=' + attachmentId, apiConfig.create());
        }
    }
}]);