﻿// registration web service proxy
webservices.factory('taxCalendarService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {

        getActiveEntityList: function () {
            return $http.get('/calendar/getActiveEntityList', apiConfig.create());
        },
        getTaskTypeList: function () {
            return $http.get('/calendar/getTaskTypeList', apiConfig.create());
        },
        getAllTaskTypeList: function () {
            return $http.get('/calendar/getAllTaskTypeList', apiConfig.create());
        },
        saveTaskType: function (data) {
            return $http.post('/calendar/saveTaskType', data, apiConfig.create());
        },
        getCalendarConfigList: function (queryParam) {
            return $http.post('/calendar/getCalendarConfigList', queryParam, apiConfig.create());
        },
        getCalendarConfigById: function (configID) {
            return $http.get('/calendar/getCalendarConfigById/' + configID, apiConfig.create());
        },
        saveCalendarConfig: function (data) {
            return $http.post('/calendar/saveCalendarConfig', data, apiConfig.create());
        },
        getCalendarDataForDisplay: function (startData, endDate) {
            return $http.post('/calendar/getCalendarDataForDisplay', { queryStartTime: new Date(startData), queryEndTime: new Date(endDate), userID: '', userName: '' }, apiConfig.create());
        },
        getMaxNumber: function () {
            return $http.get('/calendar/getMaxConfigOrder', apiConfig.create());
        },





        test: function () { return $http.get('/taxCalendar/test', apiConfig.create()); },
        getWorkPlaceList: function () {
            return $http.get('/taxCalendar/getWorkPlaceList', apiConfig.create());
        },
        deleteTaxProject: function(taxProjectId){
            return $http.post('/taxCalendar/deleteTaxProject/' + taxProjectId, {}, apiConfig.create());
        },
        saveWorkPlace: function (data) {
            return $http.post('/taxCalendar/saveWorkPlace', data, apiConfig.create());
        },
        deleteWorkPlace: function(workPlaceId){
            return $http.post('/taxCalendar/deleteWorkPlace/' + workPlaceId, {}, apiConfig.create());
        },


        getTaxCalendarUserCompanys: function (userName) {
            return $http.get('/taxCalendar/getTaxCalendarUserCompanys/' + userName, apiConfig.create());
        },
        checkUserCompanyPromiss: function (queryDto) {
            return $http.post('/taxCalendar/checkUserCompanyPromiss', queryDto, apiConfig.create());
        }
    };
}]);